﻿Public Class Form1

    Private WithEvents dgvClientes As New DataGridView()
    ' Declara um ArrayList para servir como fonte de dados
    Private clientes As New System.Collections.ArrayList()

    ' Declare um objeto Cliente para armazenar dadaos para uma linha sendo editada
    Private clienteInEdit As Cliente

    ' Declare uma variável para armazenar o index da linha sendo editada
    ' O valor igual a -1 indica que não existe linha em edição
    Private linhaInEdit As Integer = -1

    ' Declare uma variável para indicar o escopo do commit
    ' Defina o valor para False para usar o comite a nível de célula
    Private linhaScopeCommit As Boolean = True

    <STAThreadAttribute()>
    Public Shared Sub Main()
        Application.Run(New Form1())
    End Sub

    Public Sub New()
        ' Inicializa o formulário
        'define as dimensões
        Me.Width = 600
        Me.Height = 400
        'define o texto do formulário
        Me.Text = "Usando o DataGridView no modo Virtual"
        'preenche o form com o datagridview
        Me.dgvClientes.Dock = DockStyle.Fill
        'define a cor de fundo do datagridview
        dgvClientes.BackgroundColor = Color.BurlyWood
        'incluir o datagridview nos controles do formulário
        Me.Controls.Add(Me.dgvClientes)
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' habilita o modo virtual
        Me.dgvClientes.VirtualMode = True

        ' Adiciona colunas ao datagridview
        Dim colunaNome As New DataGridViewTextBoxColumn()
        With colunaNome
            .HeaderText = "Nome"
            .Name = "Nome"
        End With

        Dim colunaEmail As New DataGridViewTextBoxColumn()
        With colunaEmail
            .HeaderText = "Email"
            .Name = "Email"
        End With

        Dim colunaTelefone As New DataGridViewTextBoxColumn()
        With colunaTelefone
            .HeaderText = "Telefone"
            .Name = "Telefone"
        End With

        Dim colunaIdade As New DataGridViewTextBoxColumn()
        With colunaIdade
            .HeaderText = "Idade"
            .Name = "Idade"
        End With

        Me.dgvClientes.Columns.Add(colunaNome)
        Me.dgvClientes.Columns.Add(colunaEmail)
        Me.dgvClientes.Columns.Add(colunaTelefone)
        Me.dgvClientes.Columns.Add(colunaIdade)

        'define o modo de exibição das colunas
        Me.dgvClientes.AutoSizeColumnsMode =
            DataGridViewAutoSizeColumnsMode.AllCells

        ' Adiciona alguns dados a fonte de dados
        Me.clientes.Add(New Cliente("Macoratti", "macoratti@yahoo.com", "11-99850-6666", 45))
        Me.clientes.Add(New Cliente("Miriam", "mimi@hotmail.com.br", "11-8900-5200", 35))
        Me.clientes.Add(New Cliente("Jefferson", "jeffi@bol.com.br", "21-87550-1002", 25))
        Me.clientes.Add(New Cliente("Jessica", "jessicalang@hotmail.com", "61-9870-2580", 22))
        Me.clientes.Add(New Cliente("Janice", "janjan@uol.com.br", "21-8870-4509", 20))
        Me.clientes.Add(New Cliente("Larissa", "larissa@yahoo.com", "11-99850-6666", 15))

        ' Defina a contagem da linha incluindo a linha para novos registros
        Me.dgvClientes.RowCount = 6
    End Sub

    Private Sub dgvClientes_CellValueNeeded(ByVal sender As Object,
    ByVal e As System.Windows.Forms.DataGridViewCellValueEventArgs) Handles dgvClientes.CellValueNeeded

        ' Se esta é a linha para novos registros nenhum valor é preciso
        If e.RowIndex = Me.dgvClientes.RowCount - 1 Then
            Return
        End If

        'define um objeto do tipo Cliente
        Dim clienteTmp As Cliente = Nothing

        ' Armazena a referencie para o objeto Cliente para a linha sendo desenhada
        If e.RowIndex = linhaInEdit Then
            clienteTmp = Me.clienteInEdit
        Else
            clienteTmp = CType(Me.clientes(e.RowIndex), Cliente)
        End If

        ' Defina o valor da célula a ser exibida usando o objeto Cliente retornado
        Select Case Me.dgvClientes.Columns(e.ColumnIndex).Name
            Case "Nome"
                e.Value = clienteTmp.Nome

            Case "Email"
                e.Value = clienteTmp.Email

            Case "Telefone"
                e.Value = clienteTmp.Telefone

            Case "Idade"
                e.Value = clienteTmp.Idade

        End Select

    End Sub

    Private Sub dgvClientes_CellValuePushed(ByVal sender As Object,
    ByVal e As System.Windows.Forms.DataGridViewCellValueEventArgs) Handles dgvClientes.CellValuePushed

        'cria um objeto do tipo Cliente
        Dim clienteTmp As Cliente = Nothing

        ' Armazena a referência para o objeto CLiente para a nova linha sendo editada
        If e.RowIndex < Me.clientes.Count Then
            ' Se o usuário esta editando uma nova linha cria um novo objeto Cliente
            If Me.clienteInEdit Is Nothing Then
                Me.clienteInEdit = New Cliente(
                CType(Me.clientes(e.RowIndex), Cliente).Nome,
                CType(Me.clientes(e.RowIndex), Cliente).Email,
                CType(Me.clientes(e.RowIndex), Cliente).Telefone,
                CType(Me.clientes(e.RowIndex), Cliente).Idade)
            End If
            clienteTmp = Me.clienteInEdit
            Me.linhaInEdit = e.RowIndex
        Else
            clienteTmp = Me.clienteInEdit
        End If

        ' Define a propriedade do objeto Cliente para a célula informada
        Dim novoValor As String = TryCast(e.Value, String)

        Select Case Me.dgvClientes.Columns(e.ColumnIndex).Name
            Case "Nome"
                clienteTmp.Nome = novoValor
            Case "Email"
                clienteTmp.Email = novoValor
            Case "Telefone"
                clienteTmp.Telefone = novoValor
            Case "Idade"
                clienteTmp.Idade = novoValor
        End Select
    End Sub

    Private Sub dgvClientes_NewRowNeeded(ByVal sender As Object,
    ByVal e As System.Windows.Forms.DataGridViewRowEventArgs) Handles dgvClientes.NewRowNeeded

        ' Cria uma novo objeto Cliente quando o usuário edita a linha para novos registros
        Me.clienteInEdit = New Cliente()
        Me.linhaInEdit = Me.dgvClientes.Rows.Count - 1

    End Sub

    Private Sub dgvClientes_RowValidated(ByVal sender As Object,
    ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvClientes.RowValidated

        ' Salva as alterações feitas em uma linha
        If e.RowIndex >= Me.clientes.Count AndAlso
        e.RowIndex <> Me.dgvClientes.Rows.Count - 1 Then

            ' Adiciona um novo objeto Cliente à fonte de dados
            Me.clientes.Add(Me.clienteInEdit)
            Me.clienteInEdit = Nothing
            Me.linhaInEdit = -1

        ElseIf (Me.clienteInEdit IsNot Nothing) AndAlso
        e.RowIndex < Me.clientes.Count Then

            ' Salva o objeto Cliente modificado na fonte de dados
            Me.clientes(e.RowIndex) = Me.clienteInEdit
            Me.clienteInEdit = Nothing
            Me.linhaInEdit = -1

        ElseIf Me.dgvClientes.ContainsFocus Then

            Me.clienteInEdit = Nothing
            Me.linhaInEdit = -1

        End If

    End Sub

    Private Sub dgvClientes_RowDirtyStateNeeded(ByVal sender As Object,
    ByVal e As System.Windows.Forms.QuestionEventArgs) Handles dgvClientes.RowDirtyStateNeeded

        If Not linhaScopeCommit Then
            ' No escopo de confirmação a nível de célula (cell-level)
            ' indica se o valor da célula atual foi modificado
            e.Response = Me.dgvClientes.IsCurrentCellDirty

        End If
    End Sub

    Private Sub dgvClientes_CancelRowEdit(ByVal sender As Object,
    ByVal e As System.Windows.Forms.QuestionEventArgs) Handles dgvClientes.CancelRowEdit

        If Me.linhaInEdit = Me.dgvClientes.Rows.Count - 2 AndAlso
        Me.linhaInEdit = Me.clientes.Count Then

            ' Se o usuário cancelou a edição de uma nova linha criada 
            ' substitui o objeto Cliente com um novo objeto vazio
            Me.clienteInEdit = New Cliente()
        Else
            ' Se o usuário cancelou a edição de uma linha existente
            ' libera o objeto cliente correspondente
            Me.clienteInEdit = Nothing
            Me.linhaInEdit = -1
        End If
    End Sub

    Private Sub dgvClientes_UserDeletingRow(ByVal sender As Object,
    ByVal e As System.Windows.Forms.DataGridViewRowCancelEventArgs) Handles dgvClientes.UserDeletingRow

        If e.Row.Index < Me.clientes.Count Then
            ' Se o usuário deletou uma linha existente 
            ' remove o objeto Cliente correspondente da fonte de dados
            Me.clientes.RemoveAt(e.Row.Index)
        End If

        If e.Row.Index = Me.linhaInEdit Then
            ' Se o usuário deletou uma nova linha libera
            ' o objeto cliente correspondente
            Me.linhaInEdit = -1
            Me.clienteInEdit = Nothing
        End If
    End Sub
End Class
